##############################################################################
# REPLACE STRINGS
#
# USED NAMES:
# samplename (Img-Converter)	= PkgName
# sampledir (ksm-img-converter)	= pkg-dirname = pkg-filename (ksm-xxx)
# sampleconf (sampleconf)	= config file name (no extension)
# sampledm (sampledm)		= the daemon (rc-script, rc-link, systemd.service)
# sample (sample)		= all others
##############################################################################

# Specfile for Img-Converter

%define name	ksm-img-converter
%define version	1.0.0
%define release	9.0.0
%define _arch	noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _bindir		/usr/local/bin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	Some Image Converters
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Graphics/Convertors
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	samplepkg,samplecapab
Requires:	exiftool,netpbm,libjpeg-turbo
Requires:	ksm-libstd-sh >= 4.0.0-0.0.0
#Provides:	sampledm
#Conflicts:	sampledm-other,libsample == 0.0.0
#Obsoletes:	mysampledm

%description
This package contains following image converters which are not in the 
package netpbm and some image manipulating programs:

 bmptogif, bmptojpeg, bmptopng, bmptotiff, bmptowinicon, crop-jpeg, cut-image,
 exif-cat, exif-set, g3topng, giftobmp, giftopng, pcxtobmp, pngtobmp,
 pngtog3, pngtogif, pngtojpeg, rotateexif, rotatejpg, rotatepam,
 scale-image, scale-img2fhd, scale-img2sxga+, scale-img2widedvd

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#% makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/sampleconf.conf
#%config %{_confdir}/sampleconf.conf
#%config %{_scnfdir}/sampleconf
#%{_confdir}/sampleconf.conf

#%attr(744,root,root)/%{_rcdir}/sampledm

%attr(755,root,root)%{_bindir}/bmptogif
%attr(755,root,root)%{_bindir}/bmptojpeg
%attr(755,root,root)%{_bindir}/bmptopng
%attr(755,root,root)%{_bindir}/bmptotiff
%attr(755,root,root)%{_bindir}/bmptowinicon
%attr(755,root,root)%{_bindir}/crop-jpeg
%attr(755,root,root)%{_bindir}/cut-image
%attr(755,root,root)%{_bindir}/exif-cat
%attr(755,root,root)%{_bindir}/exif-set
%attr(755,root,root)%{_bindir}/g3topng
%attr(755,root,root)%{_bindir}/giftobmp
%attr(755,root,root)%{_bindir}/giftopng
%attr(755,root,root)%{_bindir}/pcxtobmp
%attr(755,root,root)%{_bindir}/pngtobmp
%attr(755,root,root)%{_bindir}/pngtog3
%attr(755,root,root)%{_bindir}/pngtogif
%attr(755,root,root)%{_bindir}/pngtojpeg
%attr(755,root,root)%{_bindir}/rotateexif
%attr(755,root,root)%{_bindir}/rotatejpg
%attr(755,root,root)%{_bindir}/rotatepam
%attr(755,root,root)%{_bindir}/scale-image
%attr(755,root,root)%{_bindir}/scale-img2fhd
%attr(755,root,root)%{_bindir}/scale-img2sxga+
%attr(755,root,root)%{_bindir}/scale-img2widedvd

%{_datadir}/RELEASE
%{_datadir}/VERSION

#/usr/share/applications/sample.desktop
#%{_icondir}/16x16/apps/sample.png
#%{_icondir}/22x22/apps/sample.png
#%{_icondir}/32x32/apps/sample.png
#%{_icondir}/48x48/apps/sample.png
#%{_icondir}/64x64/apps/sample.png
#%{_icondir}/128x128/apps/sample.png
#/usr/share/pixmaps/sample.png

%docdir %{_man1dir}
%{_man1dir}/bmptogif.1.gz
%{_man1dir}/bmptojpeg.1.gz
%{_man1dir}/bmptopng.1.gz
%{_man1dir}/bmptotiff.1.gz
%{_man1dir}/bmptowinicon.1.gz
%{_man1dir}/crop-jpeg.1.gz
%{_man1dir}/cut-image.1.gz
%{_man1dir}/exif-cat.1.gz
%{_man1dir}/exif-set.1.gz
%{_man1dir}/g3topng.1.gz
%{_man1dir}/giftobmp.1.gz
%{_man1dir}/giftopng.1.gz
%{_man1dir}/pcxtobmp.1.gz
%{_man1dir}/pngtobmp.1.gz
%{_man1dir}/pngtog3.1.gz
%{_man1dir}/pngtogif.1.gz
%{_man1dir}/pngtojpeg.1.gz
%{_man1dir}/rotateexif.1.gz
%{_man1dir}/rotatejpg.1.gz
%{_man1dir}/rotatepam.1.gz
%{_man1dir}/scale-image.1.gz
%{_man1dir}/scale-img2fhd.1.gz
%{_man1dir}/scale-img2sxga+.1.gz
%{_man1dir}/scale-img2widedvd.1.gz

#%docdir %{_man8dir}
#%{_man8dir}/sampledm.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
#%{_docdir}/README.de

#---------------------- ORDER OF SCRIPTLETS ----------------------------------
# O=old pkg, N=new pkg

# INSTALL:
# 1. Run %pre section of N		(Arg is 1)
# 2. Install files from N
# 3. Run %post section of N		(Arg is 1)

# UNINSTALL:
# 1. Run %preun section of O		(Arg is 0)
# 2. Delete files from O
# 3. Run %postun section of O		(Arg is 0)

# UPGRADE:
#  1. Run %pre section of O		(Arg is 2)
#  2. Install files from N
#  3. Run %post section of N		(Arg is 2)
#  4. Execute install. triggers (%triggerin in other pkgs) set off by install N
#  5. Execute installation triggers of N
#  6. Execute uninstallation triggers (%triggerun) of O
#  7. Execute uninstallation triggers (of other pkgs) set off by uninstall O
#  8. Run %preun section of O		(Arg is 1)
#  9. Delete files from O not contained in N
# 10. Run %postun section of O		(Arg is 1)

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# backup config files
#test -e %{_confdir}/sample.conf && cp %{_confdir}/sample.conf %{_confdir}/sample.conf.rpmsave
#test -e %{_scnfdir}/sample.conf && cp %{_scnfdir}/sample.conf %{_scnfdir}/sample.conf.rpmsave

# disable sample daemon and stop sampledm
#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -d -q > /dev/null 2>&1
#test -x %{_rcdir}/sampledm && %{_rcdir}/sampledm stop -q > /dev/null 2>&1

# rm links
#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
#rm -f %{_libdir}/libfuncstd-sh

# uninstall desktop files
#xdg-desktop-menu uninstall \
#	/usr/share/applications/sample.directory \
#	/usr/share/applications/sample.desktop \
#	/usr/share/applications/sample-admin.desktop

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# set config pathname and all config vars from new config file
#cf=%{_confdir}/sample.conf
#cnfvars='MyVar1 MyVar2'

#c='' s='' t='' cnt=0 i=0 ret=0
#rcfile='' updcmd='' u='' usr=''

# enable sample daemon
#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -e -q > /dev/null 2>&1

# set links
#ln -sf /usr/bin/prog %{_bindir}/myprog
#ln -sf %{_libdir}/libfuncstd-sh-%{version} %{_libdir}/libfuncstd-sh

# install desktop files
#xdg-desktop-menu install --novendor \
#	/usr/share/applications/sample.directory \
#	/usr/share/applications/sample.desktop \
#	/usr/share/applications/sample-admin.desktop

#if [ "$1" == 1 ]; then					# install package
#	echo "Configure $cf"
#	echo "Users must create HOME/.samplerc with update-sample"
#else							# upgrade package
#	# update global conf
#	if [ -e $cf.rpmsave ]; then
#		#cp $cf $cf.rpmnew
#		. $cf
#		. $cf.rpmsave
#
#		# update conf vars START -------------------------------------
#		if [ -x %{_bindir}/replcnfvar ]; then
#			for c in $cnfvars; do
#				t="\$$c"
#				eval s="$t"
#				s=\"$s\"
#				%{_bindir}/replcnfvar $cf $c "$s"
#			done
#		else
#			echo "Error - cmd replcnfvar not found or not executable!" >&2
#			echo "Conf file not updated!" >&2
#		fi
#		# update conf vars STOP --------------------------------------
#
#		# update array vars START ------------------------------------
#		# array var MainArr
#		cnt=${#MainArr[@]}			# max index of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any arrays in use?
#			while [ "$i" -lt $cnt ]; do
#				let i++
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi
#		# update array vars STOP -------------------------------------
#
#		# compare new conf vars <--> old conf vars
#		diff $cf $cf.rpmsave > /dev/null 2>&1
#		ret=$?
#		if [ "$ret" -eq 0 ]; then
#			rm $cf.rpmsave
#		else
#			echo "Check $cf"
#		fi
#	fi
#
#	# update all users conf START ----------------------------------------
#	rcfile='.samplerc'
#	updcmd="%{_bindir}/update-sample -q"
#	usr=`/usr/bin/grep /home/ /etc/passwd | /usr/bin/cut -d : -f 1`
#	for u in "$usr"; do
#		if [ -e /home/$u/$rcfile ]; then
#			/bin/su $u -c "$updcmd"
#		fi
#	done
#	if [ -e /root/$rcfile ]; then
#		$updcmd
#	fi
#	# update all users conf STOP -----------------------------------------
#
#	echo "If new version then users must update HOME/.samplerc with update-sample"
#fi
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

#if [ "$1" == 0 ]; then					# remove package
	# backup config files
	#test -e %{_confdir}/sample.conf && cp %{_confdir}/sample.conf %{_confdir}/sample.conf.rpmsave
	#test -e %{_scnfdir}/sample.conf && cp %{_scnfdir}/sample.conf %{_scnfdir}/sample.conf.rpmsave

	# disable sample daemon and stop sampledm
	#test -x %{_bindir}/togglesample && %{_bindir}/togglesample -d -q > /dev/null 2>&1
	#test -x %{_rcdir}/sampledm && %{_rcdir}/sampledm stop -q > /dev/null 2>&1

	# rm links
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog
	#rm -f %{_libdir}/libfuncstd-sh

	# uninstall desktop files
	#xdg-desktop-menu uninstall \
	#	/usr/share/applications/sample.directory \
	#	/usr/share/applications/sample.desktop \
	#	/usr/share/applications/sample-admin.desktop
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/sample
#else							# upgrade package
fi
exit 0

%changelog
* Mon Jan 06 2025 Repomaster <repomaster@kaesmann-online.de> 1.0.0-9.0.0
- pngtojpeg has been revised/improved
  (added options -a, -r).

* Sat Feb 05 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.0-8.1.0
- Following programs have been revised/improved:
  rotatepam, scale-image

* Thu Jan 06 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.0-8.0.0
- Update to the libfuncstd-sh 4.0.0

* Wed Oct 06 2021 Repomaster <repomaster@kaesmann-online.de> 1.0.0-7.2.1
- The documentation of scale-image has been revised.

* Fri Dec 04 2020 Repomaster <repomaster@kaesmann-online.de> 1.0.0-7.2.0
- bmptopng has been revised/improved.

* Sat Oct 17 2020 Repomaster <repomaster@kaesmann-online.de> 1.0.0-7.1.0
- scale-image has been revised/improved
  (get filetype from ext.).

* Sun Apr 05 2020 Repomaster <repomaster@kaesmann-online.de> 1.0.0-7.0.0
- Added crop-jpeg.

* Sat Apr 04 2020 Repomaster <repomaster@kaesmann-online.de> 1.0.0-6.1.0
- scale-image has been revised/improved
  (added option -a).

* Wed Feb 19 2020 Repomaster <repomaster@kaesmann-online.de> 1.0.0-6.0.0
- Added scale-img2widedvd.
- Removed size-pngto720

* Thu Apr 19 2018 Repomaster <repomaster@kaesmann-online.de> 1.0.0-5.2.0
- bmptojpeg has been revised/improved.

* Tue Jan 16 2018 Repomaster <repomaster@kaesmann-online.de> 1.0.0-5.1.0
- Following scripts have been revised
  (Now we also copy exif tags: option -t).
  scale-image, scale-img2fhd, scale-img2sxga+

* Sat Aug 26 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.0-5.0.0
- Added scale-img2fhd and scale-img2sxga+

* Tue Jul 11 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.0-4.0.0
- Added exif-cat.

* Mon Jul 10 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.0-3.0.0
- Added exif-set.

* Tue Jan 24 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.0-2.4.0
- All scripts have been revised
  (using function GetOpt).

* Sat Nov 12 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.0-2.3.0
- All scripts have been revised.

* Mon Oct 31 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.0-2.2.0
- The scripts cut-image and rotatejpg have
  been revised.

* Mon Oct 31 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.0-2.1.0
- The script cut-image has been revised
  (added support for other image types).

* Sun Oct 30 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.0-2.0.0
- Added the script cut-image.

* Fri Oct 14 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.0-1.11.0
- The script scale-image has been revised.
- The location of manpages has been changed.

* Tue Dec 29 2015 Repomaster <repomaster@kaesmann-online.de> 1.0.0-1.10.0
- The script rotatejpg has been revised.

* Tue Dec 29 2015 Repomaster <repomaster@kaesmann-online.de> 1.0.0-1.9.0
- The script rotatejpg has been revised
  (added cmds -D, -x and option -t).

* Fri Dec 18 2015 Repomaster <repomaster@kaesmann-online.de> 1.0.0-1.8.0
- The script rotatejpg has been revised
  (error in cmds -fh, -fv fixed).

* Thu Oct 08 2015 Repomaster <repomaster@kaesmann-online.de> 1.0.0-1.7.1
- The docu of the script scale-image has been revised.

* Sun Aug 16 2015 Repomaster <repomaster@kaesmann-online.de> 1.0.0-1.7.0
- The script rotatejpg has been revised
  (added cmd -n,
   added option -e,
   added par <outfile>).

* Wed Jul 15 2015 Repomaster <repomaster@kaesmann-online.de> 1.0.0-1.6.0
- The script rotatejpg has been revised
  (copy all exif data from old img to new img).

* Mon Mar 02 2015 Repomaster <repomaster@kaesmann-online.de> 1.0.0-1.5.0
- The script scale-image has been revised
  (added option -s).

* Tue Oct 14 2014 Repomaster <repomaster@kaesmann-online.de> 1.0.0-1.4.1
- The docu of the package has been revised.

* Fri Jun 13 2014 Juergen Kaesmann <juergen@kaesmann.us> 1.0.0-1.4.0
- The script scale-image has been revised
  (BMP detection).

* Wed Dec 11 2013 Juergen Kaesmann <juergen@kaesmann.us> 1.0.0-1.3.0
- The script scale-image has been revised
  (false config files tested).

* Wed Sep 25 2013 Juergen Kaesmann <juergen@kaesmann.us> 1.0.0-1.2.0
- The script rotatejpg has been revised
  (added cmds -r, -fh, -fv).

* Tue Sep 24 2013 Juergen Kaesmann <juergen@kaesmann.us> 1.0.0-1.1.0
- The script rotatejpg has been revised.

* Wed Sep 04 2013 Juergen Kaesmann <juergen@kaesmann.us> 1.0.0-1.0.0
- Added the scripts scale-image, size-pngto720
  and rotate-exif.

* Wed Sep 26 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.2.0
- The package has been revised.

* Mon Apr 02 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.1.2
- The release naming scheme has changed ('.ksm' is removed).

* Mon Jan 03 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.1.2.ksm
- The package name has changed to avoid conflicts with the openSUSE
  distribution. It has been prepended with 'ksm-'.

* Wed Jun 09 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.1.2.ksm
- The package is revised.

* Tue Feb 02 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.1.1.ksm
- Read version and dependency infos from external files.

* Mon Feb 01 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.1.0.ksm
- The scripts rotatejpg and rotatepam are corrected.

* Wed Jan 27 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.0.3.ksm
- The docu has changed.

* Fri Jan 15 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.0.2.ksm
- The package name (Release) has changed.

* Thu Nov 19 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.0-0.ksm.0.1
- The RPM scriptlets are corrected.

* Sun Oct 25 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.0
- The package management has changed to RPM.
